// HistogramDialog.cpp : t@C
//

#include "stdafx.h"
#include "ImageProc.h"
#include "HistogramDialog.h"
#include "afxdialogex.h"


// CHistogramDialog _CAO

IMPLEMENT_DYNAMIC(CHistogramDialog, CDialogEx)

CHistogramDialog::CHistogramDialog(std::vector<cv::Mat> histMat,
	const int drawH, const int drawW, CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_Histogram, pParent),
	m_histMat(histMat), m_drawH(drawH), m_drawW(drawW)
{
	EnableD2DSupport();
}

CHistogramDialog::~CHistogramDialog()
{
}

void CHistogramDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CHistogramDialog, CDialogEx)
	ON_REGISTERED_MESSAGE(AFX_WM_DRAW2D, &CHistogramDialog::OnAfxWmDraw2d)
END_MESSAGE_MAP()


// CHistogramDialog bZ[W nh[


afx_msg LRESULT CHistogramDialog::OnAfxWmDraw2d(WPARAM wParam, LPARAM lParam)
{
	CHwndRenderTarget* pRenderTarget = (CHwndRenderTarget*)lParam;
	ASSERT_VALID(pRenderTarget);

	if (pRenderTarget->IsValid())
	{
		// wi
		D2D1_COLOR_F color = { 0.0f, 0.0f, 0.0f }; // r, g, b
		pRenderTarget->Clear(color);

		ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();

		// B`l̕`Fij
		ID2D1SolidColorBrush* brushB;
		HRESULT hr = pHwndRenderTarget->CreateSolidColorBrush(
			D2D1::ColorF(D2D1::ColorF::Blue, 1.0f),
			&brushB);
		// G`l̕`Fi΁j
		ID2D1SolidColorBrush* brushG;
		hr = pHwndRenderTarget->CreateSolidColorBrush(
			D2D1::ColorF(D2D1::ColorF::Green, 1.0f),
			&brushG);
		// R`l̕`Fiԁj
		ID2D1SolidColorBrush* brushR;
		hr = pHwndRenderTarget->CreateSolidColorBrush(
			D2D1::ColorF(D2D1::ColorF::Red, 1.0f),
			&brushR);

		// 
		for (int j = 0; j < m_drawW; j++)
		{
			int left = j + 5;
			int right = left + 1;
			int bottom = m_drawH + 5;

			// B`lqXgO
			D2D1_RECT_F rectB = D2D1::RectF(
				left,
				bottom - cv::saturate_cast<int>(m_histMat[0].at<float>(j)),
				right,
				bottom
				);
			pHwndRenderTarget->FillRectangle(&rectB, brushB);

			// G`lqXgO
			D2D1_RECT_F rectG = D2D1::RectF(
				left,
				bottom * 2 - cv::saturate_cast<int>(m_histMat[1].at<float>(j)),
				right,
				bottom * 2
				);
			pHwndRenderTarget->FillRectangle(&rectG, brushG);

			// R`lqXgO
			D2D1_RECT_F rectR = D2D1::RectF(
				left,
				bottom * 3 - cv::saturate_cast<int>(m_histMat[2].at<float>(j)),
				right,
				bottom * 3
				);
			pHwndRenderTarget->FillRectangle(&rectR, brushR);
		}
	}
	return 0;
}
