
// ImageProcView.cpp : CImageProcView NX̎
//

#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "ImageProc.h"
#endif

#include "ImageProcDoc.h"
#include "ImageProcView.h"

#include "Helper.h"
#include "ResizeDialog.h"
#include "UnsharpMaskDialog.h"
#include "HistogramDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CImageProcView

IMPLEMENT_DYNCREATE(CImageProcView, CScrollView)

BEGIN_MESSAGE_MAP(CImageProcView, CScrollView)
	ON_COMMAND(ID_FILE_OPEN, &CImageProcView::OnFileOpen)
	ON_REGISTERED_MESSAGE(AFX_WM_DRAW2D, &CImageProcView::OnAfxWmDraw2d)
	ON_WM_DESTROY()
	ON_COMMAND(ID_Menu_Resize, &CImageProcView::OnMenuResize)
	ON_COMMAND(ID_Menu_UnsharpMask, &CImageProcView::OnMenuUnsharpmask)
	ON_COMMAND(ID_Menu_Histogram, &CImageProcView::OnMenuHistogram)
	ON_COMMAND(ID_Menu_SaveAs, &CImageProcView::OnMenuSaveas)
END_MESSAGE_MAP()

// CImageProcView RXgNV/fXgNV

CImageProcView::CImageProcView() :
	m_pD2DBitmap(NULL)
{
	// TODO: \zR[hɒǉ܂B
	EnableD2DSupport();
}

CImageProcView::~CImageProcView()
{
}

BOOL CImageProcView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CScrollView::PreCreateWindow(cs);
}

// CImageProcView `

void CImageProcView::OnDraw(CDC* /*pDC*/)
{
	CImageProcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

void CImageProcView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: ̃r[̃TCY̍vvZ܂B
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}


// CImageProcView ff

#ifdef _DEBUG
void CImageProcView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CImageProcView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CImageProcDoc* CImageProcView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CImageProcDoc)));
	return (CImageProcDoc*)m_pDocument;
}
#endif //_DEBUG


// CImageProcView bZ[W nh[


void CImageProcView::OnFileOpen()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	HRESULT hr = S_OK;

	CString filter(
		L"All Image Files|*.bmp;*.png;*.jpg;*.jpeg;*.tif|"
		L"Windows Bitmap|*.bmp|"
		L"Portable Network Graphics|*.png|"
		L"JPEG File Interchange Format|*.jpg;*.jpeg|"
		L"Tiff File|*.tif|"
		L"All Files|*.*||");
	CFileDialog openFileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, filter);

	CString cstrFileName;

	INT_PTR ret = openFileDlg.DoModal();
	if (ret == IDOK)
	{
		cstrFileName = openFileDlg.GetPathName();
		if (!cstrFileName.IsEmpty())
		{
			HRESULT hr = Load(cstrFileName);
			if (SUCCEEDED(hr))
			{
				UpdateScroll();
				//CSize sizeTotal;
				//D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
				//sizeTotal.SetSize(imageSize.width, imageSize.height);
				//SetScrollSizes(MM_TEXT, sizeTotal);
				//ScrollToPosition(CPoint(0, 0));
				// ^Cgo[
				int len = cstrFileName.GetLength();
				int pos = cstrFileName.ReverseFind(_T('\\'));
				CString cstrTitle = cstrFileName.Right(len - pos - 1) + _T(" - ImageProc");
				AfxGetMainWnd()->SetWindowText(cstrTitle);
			}
			else
			{
				MessageBox(L"摜t@Cǂݍݎs", L"G[", MB_ICONEXCLAMATION | MB_OK);
			}
		}
	}
}




afx_msg LRESULT CImageProcView::OnAfxWmDraw2d(WPARAM wParam, LPARAM lParam)
{
	CHwndRenderTarget* pRenderTarget = (CHwndRenderTarget*)lParam;
	ASSERT_VALID(pRenderTarget);

	if (pRenderTarget->IsValid())
	{
		D2D1_COLOR_F color = { 0.8f, 0.8f, 0.8f }; // r, g, b
		pRenderTarget->Clear(color);
		if (m_pD2DBitmap != NULL)
		{
			CPoint point = GetScrollPosition();
			D2D1_MATRIX_3X2_F matrix = D2D1::Matrix3x2F::Translation((float)-point.x, (float)-point.y);
			pRenderTarget->SetTransform(matrix);

			D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
			D2D1_RECT_F rectangle = D2D1::RectF(0.0f, 0.0f, (float)imageSize.width, (float)imageSize.height);

			ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();
			pHwndRenderTarget->DrawBitmap(m_pD2DBitmap, rectangle);
		}
	}
	return 0;
}


void CImageProcView::OnDestroy()
{
	CScrollView::OnDestroy();

	// TODO: ɃbZ[W nh[ R[hǉ܂B
	SafeRelease(&m_pD2DBitmap);
}

HRESULT CImageProcView::Load(CString path)
{
	HRESULT hr = S_OK;

	std::wstring wstrFilename((LPCTSTR)path);
	// ϊ
	std::string strFilename;
	wStrToMbStr(wstrFilename, strFilename);

	cv::Mat mat = cv::imread(strFilename);
	if (mat.data == NULL)
	{
		hr = E_FAIL;
	}
	else
	{
		m_mat = mat;
		hr = CreateD2DBitmapFromMat();
		this->InvalidateRect(NULL, TRUE);
	}

	return hr;
}

HRESULT CImageProcView::CreateD2DBitmapFromMat()
{
	if (m_mat.data == NULL)
	{
		return E_FAIL;
	}

	IWICImagingFactory* pIWICFactory = NULL;

	HRESULT hr = CoCreateInstance(
		CLSID_WICImagingFactory,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_PPV_ARGS(&pIWICFactory)
		);

	BYTE* data = m_mat.ptr();
	UINT stride = m_mat.step1();
	UINT width = m_mat.cols;
	UINT height = m_mat.rows;
	UINT size = stride * height;

	IWICBitmap* pWICBitmap = NULL;

	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateBitmapFromMemory(
			width,
			height,
			GUID_WICPixelFormat24bppBGR,
			stride,
			size,
			data,
			&pWICBitmap
			);
	}

	IWICFormatConverter *pConverter = NULL;
	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateFormatConverter(&pConverter);
	}

	if (SUCCEEDED(hr))
	{
		hr = pConverter->Initialize(
			pWICBitmap,
			GUID_WICPixelFormat32bppBGR,    // or GUID_WICPixelFormat32bppPBGRA
			WICBitmapDitherTypeNone,
			NULL,
			0.0f,
			WICBitmapPaletteTypeMedianCut
			);
	}

	if (m_pD2DBitmap != NULL)
	{
		SafeRelease(&m_pD2DBitmap);
		m_pD2DBitmap = NULL;
	}

	if (SUCCEEDED(hr))
	{
		CHwndRenderTarget* pRenderTarget = GetRenderTarget();
		ASSERT_VALID(pRenderTarget);
		ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();

		hr = pHwndRenderTarget->CreateBitmapFromWicBitmap(
			pConverter,
			NULL,
			&m_pD2DBitmap
			);
	}

	SafeRelease(&pConverter);
	SafeRelease(&pWICBitmap);
	SafeRelease(&pIWICFactory);

	// D2DBitmapɕϊMat̓[XĂOK
	// A摜sꍇ̓[Xi摜Ă܂j
	// m_mat.release();

	return hr;
}

void CImageProcView::UpdateScroll()
{
	CSize sizeTotal;
	D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
	sizeTotal.SetSize(imageSize.width, imageSize.height);
	SetScrollSizes(MM_TEXT, sizeTotal);
	ScrollToPosition(CPoint(0, 0));
}

void CImageProcView::OnMenuResize()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	if (m_pD2DBitmap != NULL)
	{
		CResizeDialog resizeDlg;
		resizeDlg.m_ddxRate = 100;
		INT_PTR ret = resizeDlg.DoModal();
		if (ret == IDOK)
		{
			// TCY
			double rate = resizeDlg.m_ddxRate / 100.0;
			if (m_mat.data != NULL)
			{
				cv::Mat dstMat;
				cv::resize(m_mat, dstMat, cv::Size(), rate, rate, cv::INTER_CUBIC);
				if (dstMat.data != NULL)
				{
					m_mat = dstMat;
					CreateD2DBitmapFromMat();
					UpdateScroll();
					//CSize sizeTotal;
					//D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
					//sizeTotal.SetSize(imageSize.width, imageSize.height);
					//SetScrollSizes(MM_TEXT, sizeTotal);
					//ScrollToPosition(CPoint(0, 0));
				}
			}

			InvalidateRect(NULL, FALSE);
		}
	}
}


void CImageProcView::OnMenuUnsharpmask()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	if (m_pD2DBitmap != NULL)
	{
		CUnsharpMaskDialog usmDlg;
		usmDlg.m_ddxKsizeUsm = 3;
		usmDlg.m_ddxSigmaUsm = 10.0;
		usmDlg.m_ddxAmountUsm = 50;
		usmDlg.m_ddxThUsm = 0;

		INT_PTR ret = usmDlg.DoModal();
		if (ret == IDOK)
		{
			// {JV
			int k = usmDlg.m_ddxKsizeUsm;
			double sigma = usmDlg.m_ddxSigmaUsm;

			cv::Mat gaussMat;
			cv::GaussianBlur(m_mat, gaussMat, cv::Size(k, k), sigma, sigma);
			cv::Mat subMat = m_mat - gaussMat;
			gaussMat.release();

			cv::Mat planes[3];
			// `lɕ
			cv::split(subMat, planes);
			subMat.release();
			int n = 3;
			for (int i = 0; i < n; i++)
			{
				cv::Mat tempMatUp;
				cv::threshold(planes[i], tempMatUp, usmDlg.m_ddxThUsm, 0, cv::THRESH_TOZERO);
				cv::Mat tempMatDown;
				cv::threshold(planes[i], tempMatDown, -(usmDlg.m_ddxThUsm),
					0, cv::THRESH_TOZERO_INV);
				planes[i].release();
				planes[i] = tempMatUp + tempMatDown;
				tempMatUp.release();
				tempMatDown.release();
			}
			cv::Mat thMat;
			cv::merge(planes, 3, thMat);
			for (int i = 0; i < n; i++)
			{
				planes[i].release();
			}

			cv::Mat dstMat = m_mat + thMat * usmDlg.m_ddxAmountUsm / 100.0;
			thMat.release();

			if (dstMat.data != NULL)
			{
				m_mat = dstMat;
				dstMat.release();
				CreateD2DBitmapFromMat();
				// 摜TCY͓Ȃ̂UpdateScroll()͕sv
			}

			InvalidateRect(NULL, FALSE);
		}
	}
}


void CImageProcView::OnMenuHistogram()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	if (m_pD2DBitmap != NULL)
	{
		const int ch = m_mat.channels();

		// 3ch̃qXgOf[^Matp
		std::vector<cv::Mat> histMat(3);
		const int hist_size = 256;
		const int hdims[] = { hist_size };
		const float hranges[] = { 0,256 };
		const float* ranges[] = { hranges };
		double max_val = 0.0;

		// B, G, RƂɃqXgOvZ
		for (int i = 0; i < ch; i++)
		{
			cv::calcHist(&m_mat, 1, &i, cv::Mat(), histMat[i], 1, hdims, ranges, true, false);
			double tmp_val;
			cv::minMaxLoc(histMat[i], 0, &tmp_val);
			max_val = max_val < tmp_val ? tmp_val : max_val;
		}

		// 100sNZŐK
		int drawH = 100;

		for (int i = 0; i < ch; i++)
		{
			histMat[i].convertTo(histMat[i], histMat[i].type(),
				max_val ? (double)drawH / max_val : 0.0, 0);
		}

		// qXgO_CAO\ĕ`
		CHistogramDialog hstDlg(histMat, drawH, hist_size);
		hstDlg.DoModal();
	}
}


void CImageProcView::OnMenuSaveas()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	if (m_mat.data != NULL)
	{
		// t@Cۑ_CAOőI\Ȋgqݒ
		CString filter(
			L"Windows Bitmap|*.bmp|"
			L"JPEG File Interchange Format|*.jpg;*.jpeg|"
			);
		// t@Cۑ_CAOi㏑mFwj
		CFileDialog saveFileDlg(FALSE, NULL, NULL, OFN_OVERWRITEPROMPT, filter);
		if (saveFileDlg.DoModal() == IDOK)
		{
			// ݒ肳ꂽt@CpX擾
			CString cstrFileName = saveFileDlg.GetPathName();
			if (!cstrFileName.IsEmpty())
			{
				// UNICODE}`oCg֕ϊ
				std::wstring wstrFilename((LPCTSTR)cstrFileName);
				std::string strFilename;
				wStrToMbStr(wstrFilename, strFilename);
				// gq擾
				std::wstring ext = getExtension(wstrFilename);
				if (ext == L"jpg")	// JPEG
				{
					std::vector<int> params(2);
					params[0] = cv::IMWRITE_JPEG_QUALITY;  // ki
					params[1] = 100;    // ō掿
					cv::imwrite(strFilename, m_mat, params);
				}
				else if (ext == L"bmp")	// BMP
				{
					cv::imwrite(strFilename, m_mat);
				}
			}
		}
	}
}
