
// ChildView.cpp : CChildView NX̎
//

#include "stdafx.h"
#include "BackgroundSubtraction.h"
#include "ChildView.h"

#include "Helper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView() : m_pD2DBitmap(NULL)
{
	EnableD2DSupport();
	// wivZp
	m_pMOG2 = cv::createBackgroundSubtractorMOG2();
}

CChildView::~CChildView()
{
	SafeRelease(&m_pD2DBitmap);
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_COMMAND(ID_Menu_Open, &CChildView::OnMenuOpen)
	ON_REGISTERED_MESSAGE(AFX_WM_DRAW2D, &CChildView::OnAfxWmDraw2d)
	ON_WM_TIMER()
END_MESSAGE_MAP()



// CChildView bZ[W nh[

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // `̃foCX ReLXg
	
	// TODO: ɃbZ[W nh[ R[hǉ܂B
	
	// bZ[W̕`̂߂ CWnd::OnPaint() ĂяoȂłB
}



void CChildView::OnMenuOpen()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CString filter(
		L"All Movie Files|*.avi;*.mp4;*.mov;*.tif|"
		L"AVI|*.avi|"
		L"MPEG4|*.mp4|"
		L"Quick Time|*.mov|"
		L"All Files|*.*||");
	CFileDialog openFileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, filter);

	CString cstrFileName;

	if (openFileDlg.DoModal() == IDOK)
	{
		cstrFileName = openFileDlg.GetPathName();

		HRESULT hr = CreateCapture(cstrFileName);
		if (SUCCEEDED(hr))
		{
			// t[[g擾
			double fps = m_videoCapture.get(cv::CAP_PROP_FPS);
			// \p̃^C}[Ԋuݒimł͂Ȃj
			int interval = (int)((1.0 / fps) * 1000);
			SetTimer(1, interval, NULL);
			//this->InvalidateRect(NULL, TRUE);
		}
		else
		{
			MessageBox(L"t@Cǂݍݎs", L"G[", MB_ICONEXCLAMATION | MB_OK);
		}
	}
}


afx_msg LRESULT CChildView::OnAfxWmDraw2d(WPARAM wParam, LPARAM lParam)
{
	CHwndRenderTarget* pRenderTarget = (CHwndRenderTarget*)lParam;
	ASSERT_VALID(pRenderTarget);

	if (pRenderTarget->IsValid())
	{
		D2D1_COLOR_F color = { 0.8f, 0.8f, 0.8f }; // r, g, b
		pRenderTarget->Clear(color);
		if (m_pD2DBitmap != NULL)
		{
			ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();
			D2D1_SIZE_F rtSize = pHwndRenderTarget->GetSize();
			// Z^[킹
			float ratio = 0.0;
			D2D1_RECT_F rectangle;
			D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
			float imageAspect = (float)imageSize.width / (float)imageSize.height;
			float rtAspect = (float)rtSize.width / (float)rtSize.height;
			if (rtAspect > imageAspect)
			{
				// ʂ̕
				// cɍ킹
				ratio = imageSize.height / rtSize.height;
				float imageWidth = (float)imageSize.width / ratio;
				float pad = (rtSize.width - imageWidth) / 2.0f;
				rectangle = D2D1::RectF(pad, 0.0f, pad + imageWidth, rtSize.height);
			}
			else
			{
				// ʂ̕c
				// ɍ킹
				ratio = imageSize.width / rtSize.width;
				float imageHeight = (float)imageSize.height / ratio;
				float pad = (rtSize.height - imageHeight) / 2.0f;
				rectangle = D2D1::RectF(0.0f, pad, rtSize.width, pad + imageHeight);
			}

			// Draws an image and scales it to the current window size
			pHwndRenderTarget->DrawBitmap(m_pD2DBitmap, rectangle);
		}
	}
	return TRUE;
}


void CChildView::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	if (nIDEvent == 1)
	{
		bool ret = ShowCapture();
		if (ret == false)
		{
			KillTimer(nIDEvent);
		}
	}

	CWnd::OnTimer(nIDEvent);
}

HRESULT CChildView::CreateD2DBitmapFromMat()
{
	if (m_mat.data == NULL)
	{
		return E_FAIL;
	}

	IWICImagingFactory* pIWICFactory = NULL;

	HRESULT hr = CoCreateInstance(
		CLSID_WICImagingFactory,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_PPV_ARGS(&pIWICFactory)
		);

	BYTE* data = m_mat.ptr();
	UINT stride = m_mat.step1();
	UINT width = m_mat.cols;
	UINT height = m_mat.rows;
	UINT size = stride * height;

	IWICBitmap* pWICBitmap = NULL;

	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateBitmapFromMemory(
			width,
			height,
			GUID_WICPixelFormat24bppBGR,
			stride,
			size,
			data,
			&pWICBitmap
			);
	}

	IWICFormatConverter *pConverter = NULL;
	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateFormatConverter(&pConverter);
	}

	if (SUCCEEDED(hr))
	{
		hr = pConverter->Initialize(
			pWICBitmap,
			GUID_WICPixelFormat32bppBGR,    // or GUID_WICPixelFormat32bppPBGRA
			WICBitmapDitherTypeNone,
			NULL,
			0.0f,
			WICBitmapPaletteTypeMedianCut
			);
	}

	if (m_pD2DBitmap != NULL)
	{
		SafeRelease(&m_pD2DBitmap);
		m_pD2DBitmap = NULL;
	}

	if (SUCCEEDED(hr))
	{
		CHwndRenderTarget* pRenderTarget = GetRenderTarget();
		ASSERT_VALID(pRenderTarget);
		ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();

		hr = pHwndRenderTarget->CreateBitmapFromWicBitmap(
			pConverter,
			NULL,
			&m_pD2DBitmap
			);
	}

	SafeRelease(&pConverter);
	SafeRelease(&pWICBitmap);
	SafeRelease(&pIWICFactory);

	return hr;
}

double CChildView::CreateCapture(CString cstrFileName)
{
	double fps = 0.0;

	// ǂݍݍς݂Ȃ
	if (m_videoCapture.isOpened() == true)
	{
		m_videoCapture.release();
	}
	// ۑrȂۑăt@C
	if (m_videoWriter.isOpened() == true)
	{
		m_videoWriter.release();
	}

	// }`oCg֕ϊ
	std::wstring wstrFilename((LPCTSTR)cstrFileName);
	std::string strFilename;
	wStrToMbStr(wstrFilename, strFilename);

	// t@CJ
	bool ret = m_videoCapture.open(strFilename);
	if (ret == true)
	{
		ret = m_videoCapture.isOpened();
		if (ret == true)
		{
			// 摜TCY𓾂邽߂Ƀt[ǂݍ
			cv::Mat mat;
			ret = m_videoCapture.read(mat);
			if (ret == true)
			{
				// MPEG1ŕۑ
				std::string dstFilename = chengeExt(strFilename, ".mpg");
				cv::Size size = mat.size();
				fps = m_videoCapture.get(cv::CAP_PROP_FPS);
				m_videoWriter.open(
					dstFilename, cv::VideoWriter::fourcc('P', 'I', 'M', '1'),
					fps, size);
				// t[𓪂ɖ߂Ă
				m_videoCapture.set(cv::CAP_PROP_POS_FRAMES, 0);
			}
		}
	}

	return fps;
}

bool CChildView::ShowCapture()
{
	if (m_videoCapture.isOpened() == true)
	{
		// t[̍ŌɒBmF
		bool ret = m_videoCapture.grab();
		if (ret == false)
		{
			m_videoCapture.release();
			//InvalidateRect(NULL, TRUE);
			return ret;
		}

		// t[̓ǂݍ
		cv::Mat mat;
		m_videoCapture.retrieve(mat);
		// 擾
		cv::Mat subMat;
		m_pMOG2->apply(mat, subMat);

		// 摜1`lȂ̂ŁADirect2Dp3`l摜쐬
		std::vector<cv::Mat> mv;
		mv.push_back(subMat);
		mv.push_back(subMat);
		mv.push_back(subMat);

		// }[W
		cv::Mat margeMat;
		cv::merge(mv, margeMat);

		// t@Co
		if (m_videoWriter.isOpened() == true)
		{
			m_videoWriter << margeMat;
		}

		// Ỏ摜[Xɑ
		m_mat = margeMat;
		// `
		CreateD2DBitmapFromMat();
		InvalidateRect(NULL, FALSE);
	}

	return true;
}